stages:
  - validate
  - security
  - test
  - deploy

pep8_check_style:
  tags:
    - docker
  image: python:3.8
  stage: validate
  before_script:
    - pip install -r requirements-dev.txt
  script:
    - pycodestyle --show-source --show-pep8 --exclude="docs,venv,.eggs,versioneer.py,drb/drivers/wms/_version.py"

check_dependency_licenses:
  tags:
    - docker
  image: python:3.8
  stage: validate
  before_script:
    - pip install -r requirements.txt -r requirements-dev.txt
  script:
    - liccheck -s liccheck.ini -r requirements.txt

unit_tests_3.8:
  tags:
    - docker
  image: python:3.8
  stage: test
  before_script:
    - pip install -r requirements.txt -r requirements-dev.txt
    - python -m build
  script:
    - coverage run
    - coverage xml -o coverage.xml
    - coverage report
    - coverage-badge
  coverage: '/TOTAL.+ ([0-9]{1,3}%)/'
  artifacts:
    reports:
      coverage_report:
        coverage_format: cobertura
        path: coverage.xml

unit_tests_3.11:
  tags:
    - docker
  image: python:3.11
  stage: test
  before_script:
    - pip install -r requirements.txt -r requirements-dev.txt
    - python -m build
  script:
    - python -m unittest -v

unit_tests_3_windows:
  tags:
    - windows
  image: winamd64/python:3.11
  stage: test
  before_script:
    - pip install -r requirements.txt -r requirements-dev.txt
    - python -m build
  script:
    - python -m unittest -v
  allow_failure: true

release:
  tags:
    - docker
  image: python:3.8
  stage: deploy
  before_script:
    - pip install -r requirements.txt -r requirements-dev.txt
    - python -m build
  script:
    - pip install dist/drb-driver-wms-$CI_COMMIT_TAG.tar.gz
    - python -m twine upload dist/*
  only:
    - tags

pages:
  stage: deploy
  image: python:3.8
  before_script:
    - pip install -r requirements.txt -r requirements-doc.txt
  script:
    - sphinx-build -b html docs public
  artifacts:
    paths:
      - public
  only:
    - tags

sast:
  stage: security
include:
  - template: Security/SAST.gitlab-ci.yml
